agebound = '[<>]'
d = '\\ '
integer = '[0-9]+'
years = f'{integer}y'
months = f'{integer}m'
weeks = f'{integer}w'
days = f'{integer}d'
ageduration = (
    f'((?P<years>{years})({d}(?P<months1>{months}))?({d}(?P<weeks1>{weeks}))?'
    f'({d}(?P<days1>{days}))?|(?P<months2>{months})({d}(?P<weeks2>{weeks}))?({d}'
    f'(?P<days2>{days}))?|(?P<weeks3>{weeks})({d}(?P<days3>{days}))?|(?P<days4>{days}))'
)
age = f'((?P<agebound>{agebound}){d})?{ageduration}'
alphanum = '[a-zA-Z0-9]'
anychar = '[\t-\\U0010ffff]'
atsign = '@'
banned = (
    '[\\x00-\\x08\x0b-\x0c\\x0e-\\x1f\\x7f\\x80-\\x9f\\ud800-\\udfff'
    '\\ufffe-\\uffff]'
)
underscore = '_'
ucletter = '[A-Z]'
tagchar = f'({ucletter}|[0-9]|{underscore})'
exttag = f'{underscore}({tagchar})+'
daterestrict = 'FROM|TO|BET|AND|BEF|AFT|ABT|CAL|EST'
calendar = f'(?!{daterestrict})(GREGORIAN|JULIAN|FRENCH_R|HEBREW|{exttag})'
restricted_name_first = '[a-zA-Z0-9]'
restricted_name_chars = '[a-zA-Z0-9!#$&\\-^_.+]'
restricted_name = f'{restricted_name_first}({restricted_name_chars}){{,126}}'
type_name = f'{restricted_name}'
ietf_token = f'{type_name}'
tchar = "[!#$%&'*+\\-.^_`|~0-9a-zA-Z]"
token = f'({tchar})+'
x_token = f'x-{token}'
extension_token = f'({ietf_token}|{x_token})'
composite_type = f'(message|multipart|{extension_token})'
day = f'{integer}'
stdtag = f'{ucletter}({tagchar})*'
month = f'(?!{daterestrict})({stdtag}|{exttag})'
year = f'{integer}'
epoch = f'(?!{daterestrict})(BCE|{exttag})'
date = f'({calendar}{d})?(({day}{d})?{month}{d})?{year}({d}{epoch})?'
date_capture = f'((?P<calendar>{calendar}){d})?(((?P<day>{day}){d})?(?P<month>{month}){d})?(?P<year>{year})({d}(?P<epoch>{epoch}))?'
dateapprox = f'(?P<qualifier>ABT|CAL|EST){d}(?P<dateapprox>{date})'
dateexact = f'(?P<day>{day}){d}(?P<month>{month}){d}(?P<year>{year})'
dateperiod = f'((TO{d}(?P<todate1>{date}))?|FROM{d}(?P<fromdate>{date})({d}TO{d}(?P<todate2>{date}))?)'
daterange = f'(BET{d}(?P<between>{date}){d}AND{d}(?P<and>{date})|AFT{d}(?P<after>{date})|BEF{d}(?P<before>{date}))'
datevalue = f'({date}|{dateperiod}|{daterange}|{dateapprox})?'
discrete_type = f'(text|image|audio|video|application|{extension_token})'
stdenum = f'({stdtag}|{integer})'
enum = f'({stdenum}|{exttag})'
tag = f'({stdtag}|{exttag})'
eol = '(\\\r(\\\n)?|\\\n)'
singleton = '[0-9A-WY-Za-wy-z]'
extension = f'{singleton}(-({alphanum}){{2,8}})+'
extlang = '[a-zA-Z]{3}(-[a-zA-Z]{3}){,2}'
fraction = '[0-9]+'
irregular = (
    '(en-GB-oed|i-ami|i-bnn|i-default|i-enochian|i-hak|'
    'i-klingon|i-lux|i-mingo|i-navajo|i-pwn|i-tao|i-tay|'
    'i-tsu|sgn-BE-FR|sgn-BE-NL|sgn-CH-DE)'
)
regular = (
    '(art-lojban|cel-gaulish|no-bok|no-nyn|zh-guoyu|zh-hakka|'
    'zh-min|zh-min-nan|zh-xiang)'
)
grandfathered = f'({irregular}|{regular})'
hour = '([0-9]|[01][0-9]|2[0123])'
subtype_name = f'{restricted_name}'
iana_token = f'{subtype_name}'
language = f'([a-zA-Z]{{2,3}}(-{extlang})?|[a-zA-Z]{{4}}|[a-zA-Z]{{5,8}})'
script = '[a-zA-Z]{4}'
region = '([a-zA-Z]{2}|[0-9]{3})'
variant = f'(({alphanum}){{5,8}}|[0-9]({alphanum}){{3}})'
privateuse = f'[xX](-({alphanum}){{1,8}})+'
langtag = (
    f'{language}(-{script})?(-{region})?(-{variant})*(-{extension})*(-'
    f'{privateuse})?'
)
language_tag = f'({langtag}|{privateuse}|{grandfathered})'
nonzero = '[1-9]'
level = f'(?P<level>0|{nonzero}[0-9]*)'
xref = f'{atsign}({tagchar})+{atsign}'
voidptr = '@VOID@'
pointer = f'(?P<pointer>{voidptr}|{xref})'
nonat = '[\t -?A-\\U0010ffff]'
noneol = '[\t -\\U0010ffff]'
linestr = f'(?P<linestr>({nonat}|{atsign}{atsign})({noneol})*)'
lineval = f'({pointer}|{linestr})'
line = f'{level}{d}((?P<xref>{xref}){d})?(?P<tag>{tag})({d}{lineval})?{eol}'
nocommasp = '[\t-\\x1d!-+\\--\\U0010ffff]'
nocomma = '[\t-+\\--\\U0010ffff]'
listitem = f'({nocommasp}|{nocommasp}({nocomma})*{nocommasp})?'
listdelim = f'({d})*,({d})*'
list = f'{listitem}({listdelim}{listitem})*'
list_enum = f'{enum}({listdelim}{enum})*'
list_text = f'{list}'
type = f'({discrete_type}|{composite_type})'
subtype = f'({extension_token}|{iana_token})'
ows = '[ \t]*'
parameter_name = f'{token}'
obs_text = '[\\x80-\\xff]'
qdtext = f'([\t !#-\\[\\]-~]|{obs_text})'
quoted_pair = f'\\\\([\t !-~]|{obs_text})'
quoted_string = f'"({qdtext}|{quoted_pair})*"'
parameter_value = f'({token}|{quoted_string})'
parameter = f'{parameter_name}={parameter_value}'
parameters = f'({ows};{ows}({parameter})?)*'
mediatype = f'{type}/{subtype}{parameters}'
minute = '[012345][0-9]'
namechar = '[ -.0-\\U0010ffff]'
namestr = f'({namechar})+'
personalname = f'({namestr}|(?P<given>{namestr})?/(?P<surname>{namestr})?/(?P<suffix>{namestr})?)'
second = '[012345][0-9]'
text = f'({anychar})*'
special = f'{text}'
time = f'(?P<hour>{hour}):(?P<minute>{minute})(:(?P<second>{second})(\\.(?P<fraction>{fraction}))?)?(?P<tz>Z)?'
boolean = 'Y'
